package models

type PostReport struct {
	BaseModel[PostReportID]
	PostID            PostID      `json:"post_id"`
	ReportBy          UserID      `json:"report_by"`
	ReportDescription string      `json:"report_description"`
	AuditBy           *UserID     `json:"audit_by"`
	AuditDescription  string      `json:"audit_description"`
	ReportType        ReportType  `json:"report_type" gorm:"type:enum('duplicate','missing_data','rating_abuse','illegal_content')"`
	ReportState       ReportState `json:"report_state" gorm:"type:enum('pending_unclaimed', 'pending', 'approved', 'partial', 'rejected')"`
}

func (PostReport) TableName() string {
	return "PostReport"
}
